# Go

*This article is about the game of go, for programming language see [golang](goland.md).*

{ I am still learning the beautiful game of go, please excuse potential unintentional errors here. ~drummyfish }

Go is an old two-player board [game](game.md) that originated in Asia, one of the most beautiful, deep and popular games of this type in history, whose significance can be compared to that of [chess](chess.md), despite it remaining popular mostly in Asia.

**Compared to chess** the rules of go are much more simple -- which is part of the game's [beauty](beauty.md) (see [easy to learn, hard to master](easy_to_learn_hard_to_master.md)) -- though the emergent complexity of those few rules is grandiose; so much so that to play the game well may be even harder than to play chess, as there are many more possibilities and mere calculation is not enough to be strong, one needs to develop a strong intuition; this is also the reason why it took 20 more years for [computers](computer.md) to beat the best humans in go than in chess. Many say that go is yet deeper than chess and that it offers a unique experience that can't be found anywhere else. The spirit of go is also more [zen](zen.md)-like and peaceful: while chess simulates [war](war.md) (something more aligned with western mentality), go is more about dividing territory, one could even see it not as a battle but rather a creation of beautiful patterns (something better aligned with eastern mentality).

TODO: rating, programming, stats, ...

## Rules

The game's goal is basically to surround a bigger territory than the enemy player. The formal rules are pretty simple, though their implications are very complex.

Go is played by a black and white player who take turns placing stones of one's own color on intersections of lines on the game board. The stones are all the same (there are no different types of stones like in chess) and they cannot move; once a stone is placed, it stays on its position until the end of the game, or until it is captured by the enemy player. The board size is 19x19, but for for students and quick games 13x13 and 9x9 boards are also used. Black plays first, which gives him a slight advantage; for this white gets bonus points at the end of the game, so called *komi*, which is usually set to be 6.5 points (the half point eliminates the possibility of a draw).

Any player can pass on his move, i.e. making a move isn't mandatory. However you basically always want to make a move, you one only passes when he feels there is nothing more to be gained and the game should end. If both player pass consecutively, the game ends.

The *ko* rule states that one mustn't make a move that returns the board to the immediately previous state; this basically applies just to the situation in which the enemy takes your stone and you would just place it back, retaking his capturing stone. By the *ko* rule you cannot do this IMMEDIATELY, but you can still do this any further following round.

**Scoring**: there are multiple scoring systems, but the most common seems to be the following. At the

**Example:** the following is an example of the end state of a beginner game on a 9x9 board:

```
   _________________
9 |. # . . # # # O .|
8 |# . # . # O O . O|
7 |. . . # # O . O .|
6 |# . . # O . O . O|
5 |# . # O O O . . .|
4 |. # # # O O . . .|
3 |. . . # # O O . .|
2 |. . . . # # O # .|
1 |. . . . # O O O .|
  '-----------------'
   A B C D E F G H I
```

Here black's territory is 23, and black made 9 captures during the game, giving together 32 points. White's territory is 16 and he has one black prisoner (H2), giving 17 points; furthermore white made 6 captures during the game and gets 5.5 (smaller value due to only 9x9 board size) bonus points as komi, totalling 28.5 point. Therefore black wins.

TODO